#version 330

in vec3 vPosition;
in vec3 vNormal;
in vec2 vUV;

out vec3 fragVert;
out vec3 fragNormal;
out vec2 fragTexCoord;

uniform mat4 VP;
uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;

void main()
{
	mat3 normalMatrix = transpose(inverse(mat3(modelMatrix)));

	fragVert      =	vec3(modelMatrix * vec4(vPosition, 1));
	fragNormal    = normalize(normalMatrix * vNormal);
    fragTexCoord  = vUV;

	gl_Position = VP * modelMatrix * vec4(vPosition, 1);
}